;*****************************************************************
;
;	Light Speed Player v1.02
;	Fastest Amiga MOD player ever :)
;	Written By Arnaud Carr (aka Leonard / OXYGENE)
;	https://github.com/arnaud-carre/LSPlayer
;	twitter: @leonard_coder
;
;	"Insane speed" player version ( half scanline average player time! )
;	(this source code is generated by LSPConvert)
;	You can also use the generic LightSpeedPlayer.asm player ( less than 512bytes! )
;
;	MOD in  : 206KiB + 38KiB (rink-a-dink.mod)
;	LSP out : 206KiB + 23KiB
;
;	--------How to use--------- 
;
;	bsr LSP_MusicDriver+0 : Init LSP player code
;		a0: LSP music data(any memory)
;		a1: LSP sound bank(chip memory)
;		a2: DMACON 8bits byte address
;
;	bsr LSP_MusicDriver+4 : LSP player tick (call once per frame)
;		a6: should be $dff0a0 (and not $dff000)
;		Used regs: d0/a0/a1/a2/a3
;
;*****************************************************************

	opt o-	; switch off ALL optimizations(we don't want vasm to change some code size, and all optimizations are done!)

LSP_MusicDriver:
			bra.w	.LSP_PlayerInit

;LSP_MusicDriver+4		; Player tick to call each frame
			lea		.LSPVars+8(pc),a1
			move.l	(a1),a0		; byte stream
.process:	moveq	#0,d0
			move.b	(a0)+,d0
			add.w	d0,d0
			move.w	.LSP_JmpTable(pc,d0.w),d0	; 14 cycles
			jmp		.LSP_JmpTable(pc,d0.w)		; 14 cycles


.LSP_JmpTable:		; (239 codes)
			dc.w	-1		; extended code
			dc.w	.r_None-.LSP_JmpTable
			dc.w	.r_Dv-.LSP_JmpTable
			dc.w	.r_Bv-.LSP_JmpTable
			dc.w	.r_ArCr-.LSP_JmpTable
			dc.w	.r_Cr-.LSP_JmpTable
			dc.w	.r_Dp-.LSP_JmpTable
			dc.w	.r_ArBrCr-.LSP_JmpTable
			dc.w	.r_Cvi-.LSP_JmpTable
			dc.w	.r_Ap-.LSP_JmpTable
			dc.w	.r_Av-.LSP_JmpTable
			dc.w	.r_Ci-.LSP_JmpTable
			dc.w	.r_AviCvi-.LSP_JmpTable
			dc.w	.r_BrCr-.LSP_JmpTable
			dc.w	.r_AviCi-.LSP_JmpTable
			dc.w	.r_AvpiCi-.LSP_JmpTable
			dc.w	.r_Cp-.LSP_JmpTable
			dc.w	.r_ArCrDr-.LSP_JmpTable
			dc.w	.r_Bp-.LSP_JmpTable
			dc.w	.r_AvBv-.LSP_JmpTable
			dc.w	.r_ArBrCrDrp-.LSP_JmpTable
			dc.w	.r_BvCvp-.LSP_JmpTable
			dc.w	.r_ArBvCr-.LSP_JmpTable
			dc.w	.r_AvpiCvi-.LSP_JmpTable
			dc.w	.r_Ar-.LSP_JmpTable
			dc.w	.r_ArCrDrp-.LSP_JmpTable
			dc.w	.r_AviBvpiCi-.LSP_JmpTable
			dc.w	.r_ArBrCrDr-.LSP_JmpTable
			dc.w	.r_CrDp-.LSP_JmpTable
			dc.w	.r_Cvpi-.LSP_JmpTable
			dc.w	.r_ApiBvpiCvi-.LSP_JmpTable
			dc.w	.r_Cv-.LSP_JmpTable
			dc.w	.r_BvpiCvi-.LSP_JmpTable
			dc.w	.r_Avpi-.LSP_JmpTable
			dc.w	.r_ApCr-.LSP_JmpTable
			dc.w	.r_Avi-.LSP_JmpTable
			dc.w	.r_ArCrDp-.LSP_JmpTable
			dc.w	.r_ArBrCrDp-.LSP_JmpTable
			dc.w	.r_ArBr-.LSP_JmpTable
			dc.w	.r_Br-.LSP_JmpTable
			dc.w	.r_BvpiCi-.LSP_JmpTable
			dc.w	.r_AvpiBvpiCvi-.LSP_JmpTable
			dc.w	.r_BrCrDrp-.LSP_JmpTable
			dc.w	.r_AvpiBvpiCi-.LSP_JmpTable
			dc.w	.r_ApDv-.LSP_JmpTable
			dc.w	.r_AiCvi-.LSP_JmpTable
			dc.w	.r_ArBrCrDv-.LSP_JmpTable
			dc.w	.r_AviBvpiCvi-.LSP_JmpTable
			dc.w	.r_AvCr-.LSP_JmpTable
			dc.w	.r_BiCi-.LSP_JmpTable
			dc.w	.r_BrCrDrv-.LSP_JmpTable
			dc.w	.r_Bvpi-.LSP_JmpTable
			dc.w	.r_ArCrDv-.LSP_JmpTable
			dc.w	.r_CrDr-.LSP_JmpTable
			dc.w	.r_AviBvCvi-.LSP_JmpTable
			dc.w	.r_ApiBvpiCviDvi-.LSP_JmpTable
			dc.w	.r_AviCviDpi-.LSP_JmpTable
			dc.w	.r_AviCvpi-.LSP_JmpTable
			dc.w	.r_AvpiBvpi-.LSP_JmpTable
			dc.w	.r_Dr-.LSP_JmpTable
			dc.w	.r_BvDv-.LSP_JmpTable
			dc.w	.r_ApiCi-.LSP_JmpTable
			dc.w	.r_AvpiBviCvi-.LSP_JmpTable
			dc.w	.r_CrDrv-.LSP_JmpTable
			dc.w	.r_Dvi-.LSP_JmpTable
			dc.w	.r_BrCrDr-.LSP_JmpTable
			dc.w	.r_ApiCviDvi-.LSP_JmpTable
			dc.w	.r_CviDv-.LSP_JmpTable
			dc.w	.r_BvpiCiDvi-.LSP_JmpTable
			dc.w	.r_CrDrp-.LSP_JmpTable
			dc.w	.r_ApiCviDvpi-.LSP_JmpTable
			dc.w	.r_AvpiCviDvi-.LSP_JmpTable
			dc.w	.r_ApCrDv-.LSP_JmpTable
			dc.w	.r_AvpiCviDpi-.LSP_JmpTable
			dc.w	.r_BvpiCviDvi-.LSP_JmpTable
			dc.w	.r_AviCviDi-.LSP_JmpTable
			dc.w	.r_BviCi-.LSP_JmpTable
			dc.w	.r_Cvp-.LSP_JmpTable
			dc.w	.r_BvCr-.LSP_JmpTable
			dc.w	.r_AviCviDvi-.LSP_JmpTable
			dc.w	.r_BrCrDp-.LSP_JmpTable
			dc.w	.r_ArCrDrv-.LSP_JmpTable
			dc.w	.r_CiDvi-.LSP_JmpTable
			dc.w	.r_BvCp-.LSP_JmpTable
			dc.w	.r_ApiBvpiCvpi-.LSP_JmpTable
			dc.w	.r_ApiCvpi-.LSP_JmpTable
			dc.w	.r_AviBiCi-.LSP_JmpTable
			dc.w	.r_AvpiBiCi-.LSP_JmpTable
			dc.w	.r_AvpiBvCi-.LSP_JmpTable
			dc.w	.r_AiBvpiCviDpi-.LSP_JmpTable
			dc.w	.r_BrCrDv-.LSP_JmpTable
			dc.w	.r_BpiCi-.LSP_JmpTable
			dc.w	.r_ApBrCrDv-.LSP_JmpTable
			dc.w	.r_BvCvi-.LSP_JmpTable
			dc.w	.r_BrDrv-.LSP_JmpTable
			dc.w	.r_ApiBvpiCviDi-.LSP_JmpTable
			dc.w	.r_CviDpi-.LSP_JmpTable
			dc.w	.r_Bvi-.LSP_JmpTable
			dc.w	.r_AvpiBvpiCviDpi-.LSP_JmpTable
			dc.w	.r_BvCi-.LSP_JmpTable
			dc.w	.r_ApiBvpiCiDvpi-.LSP_JmpTable
			dc.w	.r_ApBp-.LSP_JmpTable
			dc.w	.r_CiDv-.LSP_JmpTable
			dc.w	.r_ArBrCrDrv-.LSP_JmpTable
			dc.w	.r_AvpiBiCvi-.LSP_JmpTable
			dc.w	.r_CiDi-.LSP_JmpTable
			dc.w	.r_Dvpi-.LSP_JmpTable
			dc.w	.r_BvpiCvpi-.LSP_JmpTable
			dc.w	.r_BvpiCviDpi-.LSP_JmpTable
			dc.w	.r_BpDv-.LSP_JmpTable
			dc.w	.r_ApiBvpiCi-.LSP_JmpTable
			dc.w	.r_AviBvpi-.LSP_JmpTable
			dc.w	.r_CviDvi-.LSP_JmpTable
			dc.w	.r_BvCviDv-.LSP_JmpTable
			dc.w	.r_AvpiBviCviDpi-.LSP_JmpTable
			dc.w	.r_BvpiCviDvpi-.LSP_JmpTable
			dc.w	.r_AvpiBvpiCvpi-.LSP_JmpTable
			dc.w	.r_BvCiDv-.LSP_JmpTable
			dc.w	.r_AiBviCvi-.LSP_JmpTable
			dc.w	.r_ApiCviDpi-.LSP_JmpTable
			dc.w	.r_AviBviCi-.LSP_JmpTable
			dc.w	.r_BpiCviDvi-.LSP_JmpTable
			dc.w	.r_BvpiDvi-.LSP_JmpTable
			dc.w	.r_CiDpi-.LSP_JmpTable
			dc.w	.r_AiBvpiCvi-.LSP_JmpTable
			dc.w	.r_CvpiDvi-.LSP_JmpTable
			dc.w	.r_ArBrpCrDr-.LSP_JmpTable
			dc.w	.r_BviCviDvpi-.LSP_JmpTable
			dc.w	.r_AviBvCviDpi-.LSP_JmpTable
			dc.w	.r_AvpiBvpiCviDi-.LSP_JmpTable
			dc.w	.r_Dpi-.LSP_JmpTable
			dc.w	.r_AviBvpiCviDpi-.LSP_JmpTable
			dc.w	.r_BvpiCviDi-.LSP_JmpTable
			dc.w	.r_AiCi-.LSP_JmpTable
			dc.w	.r_AiBpiCvi-.LSP_JmpTable
			dc.w	.r_BvCvpDr-.LSP_JmpTable
			dc.w	.r_AviBpiCviDi-.LSP_JmpTable
			dc.w	.r_AiCvpi-.LSP_JmpTable
			dc.w	.r_ArBpCr-.LSP_JmpTable
			dc.w	.r_BvpiCiDvpi-.LSP_JmpTable
			dc.w	.r_AvpiBvi-.LSP_JmpTable
			dc.w	.r_CrDv-.LSP_JmpTable
			dc.w	.r_BvpiDvpi-.LSP_JmpTable
			dc.w	.r_BiCviDpi-.LSP_JmpTable
			dc.w	.r_BrDv-.LSP_JmpTable
			dc.w	.r_ApiCiDvi-.LSP_JmpTable
			dc.w	.r_AviBvpiCpiDpi-.LSP_JmpTable
			dc.w	.r_AvBr-.LSP_JmpTable
			dc.w	.r_ApiBviCviDpi-.LSP_JmpTable
			dc.w	.r_AviBvpiCvpi-.LSP_JmpTable
			dc.w	.r_AvDp-.LSP_JmpTable
			dc.w	.r_Bi-.LSP_JmpTable
			dc.w	.r_ArBv-.LSP_JmpTable
			dc.w	.r_AviBvpiCviDvpi-.LSP_JmpTable
			dc.w	.r_AviBvpiCviDi-.LSP_JmpTable
			dc.w	.r_AiBiCi-.LSP_JmpTable
			dc.w	.r_AiBvpiCi-.LSP_JmpTable
			dc.w	.r_AviDvpi-.LSP_JmpTable
			dc.w	.r_ArBpDr-.LSP_JmpTable
			dc.w	.r_AvpiBpiCpi-.LSP_JmpTable
			dc.w	.r_Drv-.LSP_JmpTable
			dc.w	.r_ApiBvCviDvi-.LSP_JmpTable
			dc.w	.r_BrpCrDv-.LSP_JmpTable
			dc.w	.r_ArDv-.LSP_JmpTable
			dc.w	.r_AviBpiCvi-.LSP_JmpTable
			dc.w	.r_AvBvpiCvi-.LSP_JmpTable
			dc.w	.r_AvpiBpiCpiDvpi-.LSP_JmpTable
			dc.w	.r_BrpCr-.LSP_JmpTable
			dc.w	.r_ApiBpiCviDvi-.LSP_JmpTable
			dc.w	.r_Cpi-.LSP_JmpTable
			dc.w	.r_AvCviDv-.LSP_JmpTable
			dc.w	.r_AiBvpi-.LSP_JmpTable
			dc.w	.r_BiCviDi-.LSP_JmpTable
			dc.w	.r_ArBvCp-.LSP_JmpTable
			dc.w	.r_ApiBviCviDvi-.LSP_JmpTable
			dc.w	.r_BiCvi-.LSP_JmpTable
			dc.w	.r_BpiCvi-.LSP_JmpTable
			dc.w	.r_AvpiCviDvpi-.LSP_JmpTable
			dc.w	.r_AviBvpiCpi-.LSP_JmpTable
			dc.w	.r_ApBpCpDp-.LSP_JmpTable
			dc.w	.r_ApBrCr-.LSP_JmpTable
			dc.w	.r_AiBiCvi-.LSP_JmpTable
			dc.w	.r_AvpiBvpiCviDvi-.LSP_JmpTable
			dc.w	.r_ArDp-.LSP_JmpTable
			dc.w	.r_AvpiCiDvi-.LSP_JmpTable
			dc.w	.r_AvpiBpiCi-.LSP_JmpTable
			dc.w	.r_BpiCviDv-.LSP_JmpTable
			dc.w	.r_ApiBvpCviDvpi-.LSP_JmpTable
			dc.w	.r_AvBrCr-.LSP_JmpTable
			dc.w	.r_AvCviDvpi-.LSP_JmpTable
			dc.w	.r_BvpiCv-.LSP_JmpTable
			dc.w	.r_AvpiBpiCviDi-.LSP_JmpTable
			dc.w	.r_AvpiBvpCviDvpi-.LSP_JmpTable
			dc.w	.r_ArCpDv-.LSP_JmpTable
			dc.w	.r_AvBp-.LSP_JmpTable
			dc.w	.r_AvpiCvpiDvpi-.LSP_JmpTable
			dc.w	.r_AvBpDr-.LSP_JmpTable
			dc.w	.r_AvCp-.LSP_JmpTable
			dc.w	.r_AvBrCpDr-.LSP_JmpTable
			dc.w	.r_BvpiDi-.LSP_JmpTable
			dc.w	.r_AvpiBpiCviDvpi-.LSP_JmpTable
			dc.w	.r_BviCvi-.LSP_JmpTable
			dc.w	.r_AvBvDr-.LSP_JmpTable
			dc.w	.r_ApBrDv-.LSP_JmpTable
			dc.w	.r_Di-.LSP_JmpTable
			dc.w	.r_ArBrpCrDv-.LSP_JmpTable
			dc.w	.r_BvpiCvpiDvpi-.LSP_JmpTable
			dc.w	.r_AvpiBpiCviDvi-.LSP_JmpTable
			dc.w	.r_AviBvpiCviDvi-.LSP_JmpTable
			dc.w	.r_ArBrpDr-.LSP_JmpTable
			dc.w	.r_AviBvpiDpi-.LSP_JmpTable
			dc.w	.r_AvpiBvpCvpDvpi-.LSP_JmpTable
			dc.w	.r_AvpiBvCviDvi-.LSP_JmpTable
			dc.w	.r_BpDr-.LSP_JmpTable
			dc.w	.r_AvBvpiDv-.LSP_JmpTable
			dc.w	.r_CviDvpi-.LSP_JmpTable
			dc.w	.r_AviCviDvpi-.LSP_JmpTable
			dc.w	.r_CiDvpi-.LSP_JmpTable
			dc.w	.r_AviCiDpi-.LSP_JmpTable
			dc.w	.r_AiBvpiCviDi-.LSP_JmpTable
			dc.w	.r_BpDp-.LSP_JmpTable
			dc.w	.r_AvpiBviCi-.LSP_JmpTable
			dc.w	.r_ArBpCrDp-.LSP_JmpTable
			dc.w	.r_ApiCpiDvpi-.LSP_JmpTable
			dc.w	.r_AvpiCvpi-.LSP_JmpTable
			dc.w	.r_AviBviCviDvi-.LSP_JmpTable
			dc.w	.r_BviCiDvi-.LSP_JmpTable
			dc.w	.r_ApiBviCviDvpi-.LSP_JmpTable
			dc.w	.r_AviBviCviDpi-.LSP_JmpTable
			dc.w	.r_AviBvCviDi-.LSP_JmpTable
			dc.w	.r_AvpiBpiCiDvpi-.LSP_JmpTable
			dc.w	.r_ArDr-.LSP_JmpTable
			dc.w	.r_AvpiBvCpi-.LSP_JmpTable
			dc.w	.r_CpDr-.LSP_JmpTable
			dc.w	.r_ArCp-.LSP_JmpTable
			dc.w	.r_AviDvi-.LSP_JmpTable
			dc.w	.r_ArBvCvpDr-.LSP_JmpTable
			dc.w	.r_ApiBvpiCviDpi-.LSP_JmpTable
			dc.w	.r_ArCvp-.LSP_JmpTable
			dc.w	.r_rewind-.LSP_JmpTable

.r_rewind:	move.l	0-8(a1),16-8(a1)
			move.l	24-8(a1),a0
			bra.s	.process

.LSPVars:	dc.l	0			; 0  word stream loop
			dc.w	0			; 4  reloc has been done
			dc.w	0			; 6  current music BPM
			dc.l	0			; 8  byte stream
			dc.l	0			; 12 m_lfmDmaConPatch
			dc.l	0			; 16 word stream
			dc.l	0			; 20 word stream loop
			dc.l	0			; 24 byte stream loop

; WARNING: in word stream, instrument offset is shifted by -12 bytes (3 last long of .LSPVars)
.LSP_InstrumentInfo:			; (28 instruments)
			dc.w	$0000,$0004,$0a19,$0000,$0dfe,$031c
			dc.w	$0000,$95c0,$30c3,$0000,$b928,$1f0f
			dc.w	$0001,$815c,$09ad,$0001,$815c,$0001
			dc.w	$0002,$1c3e,$0851,$0002,$1c3e,$0001
			dc.w	$0000,$1436,$0329,$0000,$1436,$0001
			dc.w	$0000,$1a88,$02a1,$0000,$1a88,$0001
			dc.w	$0001,$e712,$1a96,$0002,$0b84,$085d
			dc.w	$0000,$1fca,$3afb,$0000,$1fca,$0001
			dc.w	$0000,$f746,$07b7,$0000,$f746,$0001
			dc.w	$0001,$1540,$0845,$0001,$1540,$0001
			dc.w	$0001,$06b4,$0746,$0001,$06b4,$0001
			dc.w	$0001,$31c2,$03a3,$0001,$31c2,$0001
			dc.w	$0001,$3908,$0ed3,$0001,$3908,$0001
			dc.w	$0001,$7078,$0872,$0001,$7078,$0001
			dc.w	$0002,$d77e,$1728,$0002,$d77e,$0001
			dc.w	$0002,$7996,$0937,$0002,$7996,$0001
			dc.w	$0001,$94b6,$292e,$0001,$94b6,$0001
			dc.w	$0001,$5eee,$08c5,$0001,$5eee,$0001
			dc.w	$0003,$05ce,$110a,$0003,$05ce,$0001
			dc.w	$0002,$3a9e,$1f7c,$0002,$3a9e,$0001
			dc.w	$0002,$2ce0,$06df,$0002,$2ce0,$0001
			dc.w	$0003,$27e2,$037f,$0003,$27e2,$0001
			dc.w	$0003,$2ee0,$039a,$0003,$2ee0,$0001
			dc.w	$0002,$8c04,$1645,$0002,$9ca0,$0df7
			dc.w	$0002,$c218,$0ab3,$0002,$c218,$0001
			dc.w	$0002,$b88e,$04c5,$0002,$b88e,$0001
			dc.w	$0001,$25ca,$05fc,$0001,$25ca,$0001
			dc.w	$0001,$56ae,$0420,$0001,$56ae,$0001

.resetv:	dc.l	0,0,0,0

; a0: music data (any mem)
; a1: sound bank data (chip mem)
; a2: 8bit DMACON byte address
.LSP_PlayerInit:
			move.l	#$93b876bd,d0
			cmp.l	(a1),d0
			bne.s	.dataError
			cmpi.l	#'LSP1',(a0)+
			bne.s	.dataError
			cmp.l	(a0)+,d0
			bne.s	.dataError
			lea		836(a0),a0		; skip header
			lea		.LSPVars(pc),a3
			move.l	a2,12(a3)
			move.l	a0,16(a3)		; word stream ptr
			movea.l	a0,a4
			add.l	#9634,a4
			move.l	a4,8(a3)		; byte stream ptr

			move.l	a0,(a3)	; word stream loop ptr
			move.l	a4,24(a3)	; byte stream loop ptr
			tst.b	4(a3)
			bne.s	.noReloc
			st		4(a3)
			moveq	#28-1,d0
			lea		.LSP_InstrumentInfo(pc),a0
			move.l	a1,d1
.rloop:		add.l	d1,(a0)
			add.l	d1,6(a0)
			lea		12(a0),a0
			dbf		d0,.rloop
.noReloc:	bset.b	#1,$bfe001	; disable this fucking Low pass filter!!
			lea		.LSPVars+6(pc),a0
			move.w	#125,(a0)		; music BPM
			rts

.dataError:	illegal
; 238 specific callback
.r_None:
		move.l	a0,(a1)+
		rts

.r_Dv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		rts

.r_Bv:
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		rts

.r_ArCr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		rts

.r_Cr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		rts

.r_Dp:
		move.l	a0,(a1)+
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.l	a0,(a1)
		rts

.r_ArBrCr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		rts

.r_Cvi:
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$04,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_Ap:
		move.l	a0,(a1)+
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		move.l	a0,(a1)
		rts

.r_Av:
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		rts

.r_Ci:
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$04,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviCvi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$05,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BrCr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		rts

.r_AviCi:
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$05,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiCi:
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$05,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_Cp:
		move.l	a0,(a1)+
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.l	a0,(a1)
		rts

.r_ArCrDr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		rts

.r_Bp:
		move.l	a0,(a1)+
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.l	a0,(a1)
		rts

.r_AvBv:
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		rts

.r_ArBrCrDrp:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.l	a0,(a1)
		rts

.r_BvCvp:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.l	a0,(a1)
		rts

.r_ArBvCr:
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		rts

.r_AvpiCvi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$05,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_Ar:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		rts

.r_ArCrDrp:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.l	a0,(a1)
		rts

.r_AviBvpiCi:
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ArBrCrDr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		rts

.r_CrDp:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.l	a0,(a1)
		rts

.r_Cvpi:
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$04,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ApiBvpiCvi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_Cv:
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		rts

.r_BvpiCvi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$06,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_Avpi:
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$01,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ApCr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		move.l	a0,(a1)
		rts

.r_Avi:
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$01,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ArCrDp:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.l	a0,(a1)
		rts

.r_ArBrCrDp:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.l	a0,(a1)
		rts

.r_ArBr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		rts

.r_Br:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		rts

.r_BvpiCi:
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$06,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBvpiCvi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BrCrDrp:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.l	a0,(a1)
		rts

.r_AvpiBvpiCi:
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ApDv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		move.l	a0,(a1)
		rts

.r_AiCvi:
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$05,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ArBrCrDv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		rts

.r_AviBvpiCvi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvCr:
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		rts

.r_BiCi:
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$06,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BrCrDrv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		rts

.r_Bvpi:
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$02,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ArCrDv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		rts

.r_CrDr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		rts

.r_AviBvCvi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$05,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ApiBvpiCviDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviCviDpi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviCvpi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$05,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBvpi:
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$03,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_Dr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		rts

.r_BvDv:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		rts

.r_ApiCi:
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$05,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBviCvi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_CrDrv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		rts

.r_Dvi:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$08,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BrCrDr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		rts

.r_ApiCviDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_CviDv:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$04,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BvpiCiDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0e,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_CrDrp:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.l	a0,(a1)
		rts

.r_ApiCviDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiCviDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ApCrDv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		move.l	a0,(a1)
		rts

.r_AvpiCviDpi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BvpiCviDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0e,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviCviDi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BviCi:
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$06,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_Cvp:
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.l	a0,(a1)
		rts

.r_BvCr:
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		rts

.r_AviCviDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BrCrDp:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.l	a0,(a1)
		rts

.r_ArCrDrv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		rts

.r_CiDvi:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0c,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BvCp:
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.l	a0,(a1)
		rts

.r_ApiBvpiCvpi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ApiCvpi:
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$05,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviBiCi:
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBiCi:
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBvCi:
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$05,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AiBvpiCviDpi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BrCrDv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		rts

.r_BpiCi:
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$06,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ApBrCrDv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		move.l	a0,(a1)
		rts

.r_BvCvi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$04,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BrDrv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		rts

.r_ApiBvpiCviDi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_CviDpi:
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0c,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_Bvi:
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$02,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBvpiCviDpi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BvCi:
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$04,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ApiBvpiCiDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ApBp:
		move.l	a0,(a1)+
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		move.l	a0,(a1)
		rts

.r_CiDv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$04,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ArBrCrDrv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		rts

.r_AvpiBiCvi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_CiDi:
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0c,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_Dvpi:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$08,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BvpiCvpi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$06,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BvpiCviDpi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0e,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BpDv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.l	a0,(a1)
		rts

.r_ApiBvpiCi:
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviBvpi:
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$03,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_CviDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0c,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BvCviDv:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$04,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBviCviDpi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BvpiCviDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0e,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBvpiCvpi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BvCiDv:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$04,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AiBviCvi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ApiCviDpi:
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviBviCi:
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BpiCviDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0e,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BvpiDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0a,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_CiDpi:
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0c,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AiBvpiCvi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_CvpiDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0c,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ArBrpCrDr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.l	a0,(a1)
		rts

.r_BviCviDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0e,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviBvCviDpi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBvpiCviDi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_Dpi:
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$08,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviBvpiCviDpi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BvpiCviDi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0e,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AiCi:
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$05,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AiBpiCvi:
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BvCvpDr:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.l	a0,(a1)
		rts

.r_AviBpiCviDi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AiCvpi:
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$05,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ArBpCr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.l	a0,(a1)
		rts

.r_BvpiCiDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0e,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBvi:
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$03,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_CrDv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		rts

.r_BvpiDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0a,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BiCviDpi:
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0e,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BrDv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		rts

.r_ApiCiDvi:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviBvpiCpiDpi:
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$26(a6)
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvBr:
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		rts

.r_ApiBviCviDpi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviBvpiCvpi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvDp:
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.l	a0,(a1)
		rts

.r_Bi:
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$02,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ArBv:
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		rts

.r_AviBvpiCviDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviBvpiCviDi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AiBiCi:
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AiBvpiCi:
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$09,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ArBpDr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.l	a0,(a1)
		rts

.r_AvpiBpiCpi:
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_Drv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		rts

.r_ApiBvCviDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BrpCrDv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.l	a0,(a1)
		rts

.r_ArDv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		rts

.r_AviBpiCvi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvBvpiCvi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$06,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBpiCpiDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$26(a6)
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BrpCr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.l	a0,(a1)
		rts

.r_ApiBpiCviDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_Cpi:
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$04,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvCviDv:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$04,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AiBvpi:
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$03,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BiCviDi:
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0e,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ArBvCp:
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.l	a0,(a1)
		rts

.r_ApiBviCviDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BiCvi:
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$06,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BpiCvi:
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$06,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiCviDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviBvpiCpi:
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ApBpCpDp:
		move.l	a0,(a1)+
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$26(a6)
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		move.l	a0,(a1)
		rts

.r_ApBrCr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		move.l	a0,(a1)
		rts

.r_AiBiCvi:
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBvpiCviDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ArDp:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.l	a0,(a1)
		rts

.r_AvpiCiDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBpiCi:
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BpiCviDv:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$06,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ApiBvpCviDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvBrCr:
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		rts

.r_AvCviDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0c,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BvpiCv:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$02,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBpiCviDi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBvpCviDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ArCpDv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.l	a0,(a1)
		rts

.r_AvBp:
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.l	a0,(a1)
		rts

.r_AvpiCvpiDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$26(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvBpDr:
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.l	a0,(a1)
		rts

.r_AvCp:
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.l	a0,(a1)
		rts

.r_AvBrCpDr:
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.l	a0,(a1)
		rts

.r_BvpiDi:
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0a,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBpiCviDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BviCvi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$06,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvBvDr:
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		rts

.r_ApBrDv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		move.l	a0,(a1)
		rts

.r_Di:
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$08,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ArBrpCrDv:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.l	a0,(a1)
		rts

.r_BvpiCvpiDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0e,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$26(a6)
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBpiCviDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviBvpiCviDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ArBrpDr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.l	a0,(a1)
		rts

.r_AviBvpiDpi:
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0b,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBvpCvpDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$09,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$26(a6)
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBvCviDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BpDr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		move.l	a0,(a1)
		rts

.r_AvBvpiDv:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$02,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_CviDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0c,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviCviDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_CiDvpi:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0c,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviCiDpi:
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AiBvpiCviDi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$16(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BpDp:
		move.l	a0,(a1)+
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$16(a6)
		move.l	a0,(a1)
		rts

.r_AvpiBviCi:
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$07,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ArBpCrDp:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$16(a6)
		move.l	a0,(a1)
		rts

.r_ApiCpiDvpi:
		move.b	(a0)+,$39(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$26(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiCvpi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$05,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviBviCviDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_BviCiDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0e,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ApiBviCviDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviBviCviDpi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AviBvCviDi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0d,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_AvpiBpiCiDvpi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ArDr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		rts

.r_AvpiBvCpi:
		move.b	(a0)+,$19(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$05,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_CpDr:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.l	a0,(a1)
		rts

.r_ArCp:
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.l	a0,(a1)
		rts

.r_AviDvi:
		move.b	(a0)+,$39(a6)
		move.b	(a0)+,$09(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$09,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ArBvCvpDr:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.l	a0,(a1)
		rts

.r_ApiBvpiCviDpi:
		move.b	(a0)+,$29(a6)
		move.b	(a0)+,$19(a6)
		move.l	a0,(a1)+
		move.l	(a1)+,a0
		moveq	#$0f,d0
		move.w	d0,$96-$a0(a6)
		move.b	d0,(a0)
		move.l	(a1),a0
		move.w	(a0)+,$36(a6)
		move.w	(a0)+,$16(a6)
		move.w	(a0)+,$06(a6)
		lea		.resetv(pc),a3
		movea.l	a1,a2
		add.w	(a0)+,a2
		move.l	(a2)+,$30(a6)
		move.w	(a2)+,$34(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$20(a6)
		move.w	(a2)+,$24(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,$10(a6)
		move.w	(a2)+,$14(a6)
		move.l	a2,(a3)+
		add.w	(a0)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$04(a6)
		move.l	a2,(a3)+
		move.l	a0,(a1)
		rts

.r_ArCvp:
		move.b	(a0)+,$29(a6)
		move.l	a0,(a1)+
		lea		.resetv(pc),a3
		move.l	(a3)+,a2
		move.l	(a2)+,(a6)
		move.w	(a2)+,$4(a6)
		addq.w	#4,a1
		move.l	(a1),a0
		move.w	(a0)+,$26(a6)
		move.l	a0,(a1)
		rts

